
/* very basic io.dll to TVicPort wrapper */

#include <windows.h>

static HANDLE ioh;
typedef BOOL (_stdcall* OPENTVICPORT)(void);
static OPENTVICPORT pOpenTVicPort;
typedef void (_stdcall* CLOSETVICPORT)(void);
static CLOSETVICPORT pCloseTVicPort;
typedef BOOL (_stdcall* ISDRIVEROPENED)(void);
static ISDRIVEROPENED pIsDriverOpened;
typedef UCHAR (_stdcall* READPORT)(USHORT);
static READPORT pReadPort;
typedef UCHAR (_stdcall* WRITEPORT)(USHORT,UCHAR);
static WRITEPORT pWritePort;
static int initialized;

static int open (void)
{
    ioh = LoadLibrary ("tvicport.dll");
    if (!ioh)
		return 0;
	for (;;) {
		pOpenTVicPort = (OPENTVICPORT)GetProcAddress (ioh, "OpenTVicPort");
		pCloseTVicPort = (CLOSETVICPORT)GetProcAddress (ioh, "CloseTVicPort");
		pIsDriverOpened = (ISDRIVEROPENED)GetProcAddress (ioh, "IsDriverOpened");
		pReadPort = (READPORT)GetProcAddress (ioh, "ReadPort");
		pWritePort = (WRITEPORT)GetProcAddress (ioh, "WritePort");
		if (!pOpenTVicPort || !pCloseTVicPort || !pIsDriverOpened || !pReadPort || !pWritePort)
			break;
		if (!pOpenTVicPort())
			break;
		if (!pIsDriverOpened()) {
			pCloseTVicPort();
			break;
		}
		initialized = 1;
		return 1;
	}
	FreeLibrary (ioh);
	return 0;
}

static void close (void)
{
	if (initialized)
		pCloseTVicPort ();
	FreeLibrary (ioh);
	ioh = NULL;
	initialized = 0;
}

static char rp (short int Port)
{
	return pReadPort (Port);
}
static void wp (short int Port, char Data)
{
	pWritePort (Port, Data);
}

static void crash (void)
{
	/* used to confirm that only PortIn() and PortOut() is needed */
#if 0
	long *p = 0;
	*p = 0x12345678;
#endif
}

void WINAPI PortOut(short int Port, char Data)
{
	wp (Port, Data);
}
void WINAPI PortWordOut(short int Port, short int Data)
{
	crash();
}
void WINAPI PortDWordOut(short int Port, int Data)
{
	crash();
}
char WINAPI PortIn(short int Port)
{
	return rp (Port);
}
short int WINAPI PortWordIn(short int Port)
{
	crash();
	return 0;
}
int WINAPI PortDWordIn(short int Port)
{
	crash();
	return 0;
}
void WINAPI SetPortBit(short int Port, char Bit)
{
	crash();
	wp (Port, rp (Port) | (1 << Bit));
}
void WINAPI ClrPortBit(short int Port, char Bit)
{
	crash();
	wp (Port, rp (Port) & ~(1 << Bit));
}
void WINAPI NotPortBit(short int Port, char Bit)
{
	crash();
	wp (Port, rp (Port) ^ (1 << Bit));
}
short int WINAPI GetPortBit(short int Port, char Bit)
{
	crash();
	return (rp (Port) & (1 << Bit)) ? 1 : 0;
}
short int WINAPI RightPortShift(short int Port, short int Val)
{
	crash();
	return 0;
}
short int WINAPI LeftPortShift(short int Port, short int Val)
{
	crash();
	return 0;
}
short int WINAPI IsDriverInstalled(void)
{
	return initialized;
}

BOOL APIENTRY DllMain(HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		open ();
		break;
		case DLL_PROCESS_DETACH:
		close ();
		break;
	}
    return TRUE;
}
